##############################
## Created by Sandor Laki   ##
## Email: lakis@inf.elte.hu ##
##############################

import os, pygame,math
from random import randint
import time
from pygame.locals import *
from Actor import Actor
from Globals import *
 
class Dog(Actor):
	"""The dog"""
	
	MAX_ENERGY = 1000
	CHANGE_OF_ENERGY = 1
	
		
	def __init__(self, map):
		im = pygame.image.load("./images/dog.png").convert()
        	im.set_colorkey((0xff, 0xff, 0xff), RLEACCEL)
		Actor.__init__(self,im,map)

		self.energy = self.MAX_ENERGY

		
	def update(self):
		Actor.update(self)					

	def handle_run(self):
		self.energy = self.energy-self.CHANGE_OF_ENERGY
		if self.energy<=0:
			self.energy = 0
			self.state = self.WALK

	def handle_stopped(self):			
			self.energy = min( self.energy+self.CHANGE_OF_ENERGY, self.MAX_ENERGY )


