#/usr/bin/env python 
##############################
## Created by Sandor Laki   ##
## Email: lakis@inf.elte.hu ##
##############################

import os, pygame,math 
from pygame.locals import * 
from Block import Block
from Globals import *

class Map:
	"""Map class"""
	
	def __init__(self):
		self.map = None
		self.blocksImage = pygame.image.load("./images/blocks.png").convert()
        	self.blocksImage.set_colorkey((0xff, 0xff, 0xff), RLEACCEL) 
		
		
	def loadMap(self, name):
		"""Loading a map from a map file"""
		self.map = []
		for i in range( BCKS_X ):
			self.map.append( [] )
		
		inp = open(name)
		x = 0
		y = 0
		for line in inp:
			for c in line.rstrip():
				b = Block()
				if c=='W':
					b.image = 0
					b.walkable = 1
				else:
					b.image = 1
					b.walkable = 0
				self.map[x].append( b )
				x += 1			
			y += 1
			x = 0
			if y==BCKS_Y:
				break
		inp.close()
		
	def draw(self, surface):
		"""Draw the map/background"""
		surface.fill( (0xff, 0xff, 0xff) )
		for i in range( BCKS_X ):
			for j in range( BCKS_Y ):
				im = self.map[i][j].image

				if im > -1:
					surface.blit( self.blocksImage, [i*BSIZE,j*BSIZE], [im*BSIZE, 0, BSIZE, BSIZE] )

	def isFree(self,x,y):
		"""Is the block at x,y free"""
		return x>0 and y>0 and x<BCKS_X and y<BCKS_Y and (self.map[x][y].walkable == 1)


