##############################
## Created by Sandor Laki   ##
## Email: lakis@inf.elte.hu ##
##############################

import os, pygame,math
from random import randint
import time
from pygame.locals import *
from Actor import Actor
from Globals import *
from Dog import Dog

class Sheep(Actor):
	"""A sheep"""
		
	EAT = 7001
	ESCAPE = 7002

	CIRCLE = 50
	LOOPLIMIT = 600

	def __init__(self, map, image, dog, x, y):		
		Actor.__init__(self,image,map)
		self.s_state = self.EAT
		self.dog = dog
		self.loopcnt = 0
		self.r_speed = 1
		self.w_speed = 0.5
		self.setLocation( x, y)
		
	def update(self):
		Actor.update(self)
		self.loopcnt += 1
		if self.state!=self.RUN or self.loopcnt>self.LOOPLIMIT:
			if self.dog.state == self.RUN:
				dist = (self.x-self.dog.x)*(self.x-self.dog.x) + (self.y-self.dog.y)*(self.y-self.dog.y)
				if dist < self.CIRCLE*self.CIRCLE:
					self.state = self.RUN				
				else:
					self.state = self.WALK				
			else:
				self.state = self.WALK

	def handle_walk(self):
		#print "walk"
		if self.loopcnt>self.LOOPLIMIT:
			self.loopcnt = 0
			x = randint(1,799)
			y = randint(1,599)
			self.goTo(x,y,False)
		elif self.loopcnt>self.LOOPLIMIT/2:
			self.state = self.STOPPED

	def handle_run(self):
		#print "run"
		#self.loopcnt = self.LOOPLIMIT
		i = int(self.x/BSIZE)
		j = int(self.y/BSIZE)
		mx = 0
		my = 0
		d1 = self.x-self.dog.x
		d2 = self.y-self.dog.y
		mindist = d1*d1 + d2*d2
		v = 0.0
		for k in range(-1,2):
			for l in range(-1,2):
				if (k!=0 or l!=0):
					if self.map.isFree(int(self.x)/BSIZE+k, int(self.y)/BSIZE+l):
						v = (d1+k*BSIZE)*(d1+k*BSIZE) + (d2+l*BSIZE)*(d2+l*BSIZE)
						if v>mindist:
							mindist = v
							mx = k
							my = l
		self.goTo(self.x+mx*BSIZE, self.y+my*BSIZE, True)

	def handle_stopped(self):			
			#print "stopped"
			self.loopcnt = self.LOOPLIMIT
			x = randint(1,799)
			y = randint(1,599)
			self.goTo(x,y,False)


