#/usr/bin/env python 
##############################
## Created by Sandor Laki   ##
## Email: lakis@inf.elte.hu ##
##############################


import os, pygame,math 
from pygame.locals import * 

from Game import Game
from Globals import *

class Shepherd:
	"""Shepherd game - Main class"""
	
	def __init__(self):
		pygame.init()

		self.screen = pygame.display.set_mode((SCR_X, SCR_Y),1)
		pygame.display.set_caption('Shepard')
		self.mainim = pygame.image.load("./images/main.png").convert()        	

	def run(self):
		clock = pygame.time.Clock()
		self.screen.blit( self.mainim, (0,0) )
		# main loop - 1
		while 1:
			clock.tick(30)
                	for event in pygame.event.get():
		               	if event.type == QUIT:
                			return
				elif event.type == KEYDOWN:
					if event.key == K_ESCAPE:
						return # exit
					elif event.key == K_SPACE:
						levels = ( "./data/level2.desc", "./data/level2.desc" )
						for i in levels:
							try:
								g = Game( self.screen, i )
								st = g.run()
								if st==-1:
									break
								elif st==-2:
									return
							except:
								print "Loading of "+i+" file has failed!"
						self.screen.blit( self.mainim, (0,0) )
			pygame.display.flip()


def main():
	s = Shepherd()
	try:
		s.run()
	except:
		print "Errors has been detected!"
		print "You can send error report to the author!"

#this calls the 'main' function when this script is executed
if __name__ == '__main__': main() 
	
