import os, pygame,math
from random import randint
import time
from pygame.locals import *

from Globals import *
 
class Actor(pygame.sprite.Sprite):
	"""An actor"""

	BETWEEN_BLOCKS = 1001
	ON_BLOCK = 1002

	RUN = 2001
	WALK = 2002
	#STOPPED = 2003

	def __init__(self, image, map):
		pygame.sprite.Sprite.__init__(self)
		self.map = map
		self.a_state = self.ON_BLOCK
		self.state = self.WALK
		self.image = image
		self.rect = image.get_rect()
		#self.speed = 2
		self.r_speed = 4
		self.w_speed = 2
		self.x = 0
		self.y = 0
		#self.scr_x = 0
		#self.scr_y = 0
		self.movex = 0.0
		self.movey = 0.0
		self.steps = 0
		

	def setLocation(self,x,y):
		self.map.map[self.x][self.y].occupied = 0
		self.x = x
		self.y = y
		self.map.map[self.x][self.y].occupied = 1
		self.rect.centerx = int(x*BSIZE)+BSIZE/2
		self.rect.centery = int(y*BSIZE)+BSIZE/2
		self.a_state = self.ON_BLOCK
		self.state = self.WALK
	
	def goTo(self,dirx,diry):
		if self.map.isFree(self.x+dirx,self.y+diry):
			self.map.free(self.x,self.y)			
			self.x = self.x + dirx
			self.y = self.y + diry			
			#self.rect.centerx = self.x*BSIZE+BSIZE/2
			#self.rect.centery = self.y*BSIZE+BSIZE/2
			self.steps = int(math.sqrt(BSIZE*BSIZE)/self.getSpeed())
			
			self.movex = float(dirx*BSIZE)/self.steps
			self.movey = float(diry*BSIZE)/self.steps
			self.map.occupie(self.x,self.y)
			self.a_state = self.BETWEEN_BLOCKS
			print self.movex
			print self.movey
			print self.steps

	def getSpeed(self):
		if self.state == self.RUN:
			return self.r_speed
		else:
			return self.w_speed

	def update(self):
		if self.a_state == self.BETWEEN_BLOCKS:
			self.handle_between_blocks()
		
	
	def handle_between_blocks(self):
		self.steps = self.steps - 1
		if self.steps <= 0:
			self.rect.centerx = int(self.x*BSIZE)+BSIZE/2
			self.rect.centery = int(self.y*BSIZE)+BSIZE/2
			self.a_state = self.ON_BLOCK
		else:
			self.rect.centerx = int(self.rect.centerx + self.movex)
			self.rect.centery = int(self.rect.centery + self.movey)
		
