import os, pygame,math
from random import randint
import time
from pygame.locals import *
from Actor import Actor
from Globals import *
 
class Dog(Actor):
	"""The dog"""
	
	MAX_ENERGY = 20
	CHANGE_OF_ENERGY = 2
	
		
	def __init__(self, map):
		im = pygame.image.load("./images/dog.png").convert()
        	im.set_colorkey((0xff, 0xff, 0xff), RLEACCEL)
		Actor.__init__(self,im,map)

		self.energy = self.MAX_ENERGY
		self.targetx = self.x
		self.targety = self.y
		
	def update(self):
		Actor.update(self)
		
		if (self.a_state == self.ON_BLOCK) and ( (self.targetx != self.x) or (self.targety != self.y) ):
			dirx = self.targetx-self.x
			diry = self.targety-self.y
			dirx = int(dirx/max( abs(dirx), abs(diry) ))
			diry = int(diry/max( abs(dirx), abs(diry) ))
			if self.map.isFree( self.x+dirx, self.y+diry ):
				Actor.goTo(self,dirx,diry)
			elif self.map.isFree( self.x, self.y+diry ) and diry!=0:
				Actor.goTo(self,0,diry)
			elif self.map.isFree( self.x+dirx, self.y ) and dirx!=0:
				Actor.goTo(self,dirx,0)

		if (self.a_state == self.BETWEEN_BLOCKS) and (self.state == self.RUN):
			self.energy = self.energy-self.CHANGE_OF_ENERGY
			if self.energy<=0:
				self.energy = 0
				self.state = WALK
		elif self.a_state==self.ON_BLOCK:
			self.energy = min( self.energy+self.CHANGE_OF_ENERGY, self.MAX_ENERGY )

	def stop(self):
		self.targetx = self.x
		self.targety = self.y

	def setTarget(self, x, y):
		self.targetx = x
		self.targety = y
	
