#/usr/bin/env python 

import os, pygame,math 
from pygame.locals import * 
from Block import Block
from Globals import *

class Map:
	
	def __init__(self):
		self.map = None
		self.blocksImage = pygame.image.load("./images/blocks.png").convert()
        	self.blocksImage.set_colorkey((0xff, 0xff, 0xff), RLEACCEL) 
		
		
	def loadMap(self):
		self.map = []
		for i in range( SCR_X ):
			self.map.append( [] )
		
		for i in range( SCR_X ):
			for j in range( SCR_Y ):
				b = Block()
				b.image = 0
				self.map[i].append( b )
		
	def draw(self, surface):
		surface.fill( (0xff, 0xff, 0xff) )
		for i in range( BCKS_X ):
			for j in range( BCKS_Y ):
				im = self.map[i][j].image

				if im > -1:
					surface.blit( self.blocksImage, [i*BSIZE,j*BSIZE], [im*BSIZE, 0, BSIZE, BSIZE] )

	def isFree(self,x,y):
		return (self.map[x][y].occupied == 0) and (self.map[x][y].walkable == 1)

	def free(self,x,y):
		self.map[x][y].occupied = 0

	def occupie(self,x,y):
		self.map[x][y].occupied = 1
